
#ifndef __ALGORITHMAN__LL1PARSERGENERATOR_H
#define __ALGORITHMAN__LL1PARSERGENERATOR_H

#include "ContextFreeGrammar.h"
#include "LL1Parser.h"

    namespace ContextFreeGrammars
    {

        template<class token> class LL1ParserGenerator
        {

        protected:
            ContextFreeGrammar<token> cfg;
            std::map<const NonTerminal*, std::set<Terminal<token>*> > nonterminalfirst1;
            std::map<const NonTerminal*, std::set<Terminal<token>*> > nonterminalfollow1;

            void CollectNonTerminalFirst1(const NonTerminal *targetnt);
            void CollectNonTerminalFollow1(const NonTerminal *targetnt);

            std::set<Terminal<token>*> first1(const std::vector<Symbol*>& w) const;
            std::set<Terminal<token>*> lookahead1(const NonTerminal* nt, const std::vector<Symbol*>& w) const;

        public:
            LL1ParserGenerator(const ContextFreeGrammar<token>& cfg);
            ~LL1ParserGenerator();

            bool IsLL1Grammar() const;
            LL1Parser<token>* Generate() const;
        };

    }
    
#include "LL1ParserGenerator.tpp"
    
#endif