
#include "LR0ParserGenerator.h"

ContextFreeGrammars::LR0Element::LR0Element(NonTerminal* nonterminal, ContextFreeGrammars::Production *production, int dotPosition)
{
    this->nonterminal = nonterminal;
    this->production = production;
    this->dotPosition = dotPosition;
}

bool ContextFreeGrammars::LR0Element::operator==(const ContextFreeGrammars::LR0Element& x) const
{
    if(nonterminal != x.nonterminal
    || dotPosition != x.dotPosition
    || production->produced.size() != x.production->produced.size())
        return false;
        
    for(std::vector<Symbol*>::const_iterator s = production->produced.begin(), xs = x.production->produced.begin(); s != production->produced.end(); s++, xs++)
        if(*s != *xs)
            return false;

    return true;
}

bool ContextFreeGrammars::LR0Element::operator!=(const ContextFreeGrammars::LR0Element& x) const
{
    return !operator==(x);
}

